
[markdown]

Protos is a Web Application Framework, focused on high performance, integration, ease of 
deployment, maintainability and security. Runs on UNIX-like systems such as **Linux**, **FreeBSD** & **Mac OSX**.

## Features at a Glance

- Powerful Routing & Validation
- Controller Authentication & Filters
- REST Compliant Routing
- Environment based Configuration
- Fast Configuration with bootstrap file
- Multi Core Cluster support
- Easy Deployment
- Database Drivers & Storages: MongoDB, MySQL, PostgreSQL, Redis
- Message Queue: RabbitMQ
- ORM Models, Supporting Relationships
- Query Caching for Drivers & Models
- Multiple Template Engines Supported
- View Helpers
- View Partials
- JSON Responses
- Proxy Server for Multiple Applications
- Node Inspector for debugging
- Command Line Executable to create & manage apps
- Organized Directory Structure
- Includes complete test suite

## Middleware

- [asset_compiler](middleware.html#asset_compiler) &nbsp; *Compiles LESS, Stylus and CoffeeScript. Supports watch/compress/minify*
- [aws](middleware.html#aws) &nbsp; *Amazon Web Services. Provides clients to all services (ES3, EC2, etc)*
- [bcrypt](middleware.html#bcrypt) &nbsp; *Blowfish hashing*
- [body_parser](middleware.html#body_parser) &nbsp; *Allows Parsing of POST & PUT requests & file uploads*
- [cookie_parser](middleware.html#cookie_parser) &nbsp; *Cookie Parsing*
- [csrf](middleware.html#csrf) &nbsp; *CSRF Protection*
- [logger](middleware.html#logger) &nbsp; *Logger. Supported transports: MongoDB, Redis, File & console*
- [magick](middleware.html#magick) &nbsp; *Image Processing using ImageMagick*
- [mailer](middleware.html#mailer) &nbsp; *Mailer. Supports SMTP, SES or Sendmail*
- [ markdown ](middleware.html#markdown) &nbsp; *Markdown Parser*
- [mq](middleware.html#mq) &nbsp; *Message Queue using RabbitMQ*
- [repl](middleware.html#repl) &nbsp; *Appliction Runtime REPL*
- [response_cache](middleware.html#response_cache) &nbsp; *Response Caching*
- [session](middleware.html#session) &nbsp; *Sessions Support*
- [shortcode](middleware.html#shortcode) &nbsp; *WordPress-like shortcodes*
- [socket_io](middleware.html#socket_io) &nbsp; *Socket.io integration*
- [static_server](middleware.html#static_server) &nbsp; *Static Server. Supports ranges, Conditional GETs*

## Template Engines

- [CoffeeKup](https://github.com/mauricemach/coffeekup)
- [DoT](https://github.com/olado/doT)
- [Eco](https://github.com/sstephenson/eco)
- [EJS](https://github.com/visionmedia/ejs)
- [Haml](https://github.com/visionmedia/haml.js)
- [Haml-Coffee](https://github.com/9elements/haml-coffee)
- [Handlebars](https://github.com/wycats/handlebars.js)
- [Hogan.js](https://github.com/twitter/hogan.js)
- [Jade](https://github.com/visionmedia/jade)
- [Jazz](https://github.com/shinetech/jazz)
- [JQuery Templates](https://github.com/kof/node-jqtpl)
- [JSHtml](https://github.com/LuvDaSun/jshtml)
- [Kernel](https://github.com/c9/kernel)
- [Liquor](https://github.com/chjj/liquor)
- [Swig](https://github.com/paularmstrong/swig)
- [Whiskers](https://github.com/gsf/whiskers.js/tree)

## Resources

- [Google Groups Discussion](https://groups.google.com/group/protos-web-framework)
- [Github Repository](http://github.com/derdesign/protos)

[/markdown]
